package config;


import java.sql.Driver;

public enum DBType {
    mysql5(com.mysql.cj.jdbc.Driver.class),
    mysql55(com.mysql.cj.jdbc.Driver.class),
    mysql57(com.mysql.cj.jdbc.Driver.class),
    mysql8(com.mysql.cj.jdbc.Driver.class);

    private Class<? extends Driver> driver;

    DBType(Class<? extends Driver> driver) {
        this.driver = driver;
    }

    public Class<? extends Driver> getDriver() {
        return driver;
    }

    public String getUrl(String host, int port, String name) {
        switch (DBType.valueOf(this.name())) {
            case mysql5:
            case mysql55:
            case mysql57:
            case mysql8:
                return "jdbc:mysql://" + host + ":" + port + "/" + name + "?serverTimezone=GMT%2b8";
            default:
                throw new RuntimeException("NotFound type:" + this.name());
        }
    }
}
